<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.8.00  
* Copyright (C) 2007: Fred Stuurman (fc.stuurman@hccnet.nl)
* Common functions:
* common.inc.php: last changed 04/03/2009 by Fred Stuurman (fc.stuurman@hccnet.nl)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

function sql_addslashes($a_string = '')
{
//function which will check magic quotes to be on, if not add slashes to input string.
	if (!get_magic_quotes_gpc())
	{
		$a_string = addslashes($a_string);
	}
	return $a_string;
} // end of the 'sql_addslashes()' function

function sanitize($input, $length, $type)
{
//function to sanitize user input
//$length limits the input to that amount
//$type can be S = string , I = integer , A = alpha chars only
//and U = untouched, we leave it as it is.
//add slashes for strings.
	
	if ($type == "I")
	{
		//return only integer
		$result = intval($input);
	}
	elseif ($type == "S")
	{
		//remove html tags
		$result = htmlspecialchars(strip_tags($input));
		$result = sql_addslashes($result) ;
	}
	elseif ($type == "A")
	{
		//only allow alpha characters + @
		$input = preg_replace("/[^a-zA-Z0-9]@/", "", $input);
		$result = sql_addslashes($input);
	}
	elseif ($type == "U")
	{
		//leave untouched, only add slashes if needed.
		$result = sql_addslashes($input);
	}
	else
	{
		//trigger error, we should not enter here
		trigger_error('Sanitize function error: wrong parameter given', E_USER_WARNING);
	}
	if ($length != 0)
	{
		//limit the input to $length 
		$result = substr($result, 0 , $length);
	}

	return $result;
} // end of the 'sanitize()' function


function verify_logon($user, $pass, $option)
{
# Function to verify user logon.
# $user is the username , $pass is password,
# $option can be "userlogin" and "save_newpassword""

	global $check_sessioncode, $sas_config, $table_users, $page, $section, $sas_lang, $cmsdir, $dbprefix;
	
	$table_logging = $dbprefix . "logging";
	$ip = $_SERVER["REMOTE_ADDR"];
	$pass = md5($pass);

	$login = anti_injection(strip_tags($user), strip_tags($pass));
	$query = "SELECT id, type, initial, invalid_logins, editor, access, name, password FROM $table_users 
			WHERE username = '" . $login['user'] . "' AND password = '" . $login['pass'] . "' LIMIT 1";
	$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 

	$RecordCount = mysql_num_rows($result);

	if ($RecordCount == 1)
	{
		$_SESSION['userid'] = mysql_result($result, 0, 'id');
		$_SESSION['user_type'] = mysql_result($result, 0, 'type');
		$_SESSION['editor'] = mysql_result($result, 0, 'editor');
		$_SESSION['access'] = mysql_result($result, 0, 'access');
		$name = str_replace("'", "", mysql_result($result, 0, 'name'));
		$_SESSION['name'] = $name;
		$current_password = mysql_result($result, 0, 'password'); //encrypted	
		$is_initial_logon = mysql_result($result, 0, 'initial');
		$invalid_logins = mysql_result($result, 0, 'invalid_logins');
		unset ($query);
		unset ($result);
		
		//used for logging text
		if (($_SESSION['user_type'] == 1) or ($_SESSION['user_type'] == 21))
		{
			$type_of_user = "Pupil";
		}
		elseif (($_SESSION['user_type'] == 2) or ($_SESSION['user_type'] == 22))
		{
			$type_of_user = "Teacher";
		}
		elseif ($_SESSION['user_type'] == 20)
		{
			$type_of_user = "Admin";
		}

		if ($invalid_logins > 9)		//user has been revoked.
		{
			$log_msg = "User: <b>" . $login['user'] . "</b> is revoked! Number of attempts: $invalid_logins.";
			mysql_query("INSERT INTO $table_logging (filename, line, code, message, date) 
				VALUES('IP: $ip - Login ', '-', '9999', '$log_msg', now())");
			
			print "<script language=\"Javascript\">
				   <!--
				   alert (\"" . $sas_lang['user_revoked'] . "\");
				   window.location = '$sas_config[url]$cmsdir/sendpw.php' ;
				   //-->
				   </script>";
			exit;
			return FALSE;
		}

		if (($is_initial_logon == 1) AND ($option != "save_new_password"))
		{ //force a new password
			session_unset();
			session_destroy();
			
			$log_msg = "User: <b>" . $login['user'] . "</b> requested a new password";
			mysql_query("INSERT INTO $table_logging (filename, line, code, message, date) 
						VALUES('IP: $ip - Login ', '-', '9999', '$log_msg', now())");
			
			if ($_SESSION['user_type'] == 20) //admin type users
			{
				header("Location: index.php?option=new_password&username=$login[user]");
			}
			else //teacher and pupils
			{
				print "<script language='javascript'>
						window.location = 'index.php?page=$page&section=$section&option=new_password&username=$login[user]'
						</script>";
			}
		}

		if ($option == "save_new_password")
		{
			if($current_password == md5($_POST['password_new1']))
			{
				session_unset();
				session_destroy();
				
				print "<script language=\"Javascript\">
					   <!--
					   alert (\"".$sas_lang['password_not_be_the_same']."\");
					   //-->
					   </script>";
					   
				if ($_SESSION['user_type'] == 20) //admin type users
				{
					header("Location: index.php?option=new_password&username=$login[user]");
				}
				else //teacher and pupils
				{
					print "<script language='javascript'>
							window.location = 'index.php?page=$page&section=$section&option=new_password&username=$login[user]'
							</script>";
				}
			}
			elseif (($_POST['password_new1'] == $_POST['password_new2']) AND (strlen($_POST['password_new1']) > 3))
			{ //check if both password given are equal
				
				$password = md5($_POST['password_new1']);
				
				$log_msg = "for user:" . $login['user'] . " ($type_of_user) password has been changed.";
				mysql_query("INSERT INTO $table_logging (filename, line, code, message, date) 
								VALUES('IP: $ip - Login ', '-', '9999', '$log_msg', now())");
				
				mysql_query("UPDATE $table_users SET password = '$password', invalid_logins = 0, initial = 0 WHERE username = '" . $login['user'] . "'");
				
				print "<script language=\"Javascript\">
					   <!--
					   alert (\"" . $sas_lang['password_has_changed'] . "\");
					   //-->
					   </script>";
			}
			else //not equal return to renew password form.
			{
				session_unset();
				session_destroy();
				$log_msg = "for user: <b>" . $login['user'] . "</b> ($type_of_user) <font color=\"red\">password change failed!</font>";
				mysql_query("INSERT INTO $table_logging (filename, line, code, message, date) 
								VALUES('IP: $ip - Login ', '-', '9999', '$log_msg', now())");
								
				if ($_SESSION['user_type'] == 20) //admin type users
				{
					header("Location: index.php?option=new_password&username=$login[user]&error=true");
				}
				else //teacher and pupils
				{
					print "<script language='javascript'>
							window.location = 'index.php?page=$page&section=$section&option=new_password&username=$login[user]&error=true'
							</script>";
				}
			}
		}
		
		$log_msg = "for user: <b>" . $login['user'] . "</b> (".$type_of_user.") successful!";
		
		$_SESSION['sessioncode'] = $check_sessioncode;
		mysql_query("UPDATE $table_users SET invalid_logins = 0 WHERE username = '" . $login['user'] . "'");
		mysql_query("INSERT INTO $table_logging (filename, line, code, message, date) 
						VALUES('IP: $ip - Login ', '-', '9999', '$log_msg', now())");
		
		mysql_query("DELETE from $table_logging WHERE date < current_date() - INTERVAL $sas_config[logging_retention_period] day");   //delete old loggings
	
		return TRUE;
	}
	else // username and password don't match
	{	
		$query = "SELECT invalid_logins FROM $table_users WHERE username = '" . $login['user'] . "' LIMIT 1";
		$result = mysql_query($query) or trigger_error(mysql_error().'"<br>Query : "' . $query . '".',E_USER_WARNING); 
	
		$RecordCount = mysql_num_rows($result);
	
		if ($RecordCount == 1)
		{
			$invalid_logins = mysql_result($result, 0, 'invalid_logins');
			if(($invalid_logins == 9) AND ($sas_config['email'] != ''))		//send mail to administrator
			{
				$msg = str_replace("%username%", $login['user'] , $sas_lang['user_revoked_msg'] ); //replace username
				require ("class.phpmailer.php"); //use the phpmailer class
				$mail = new PHPMailer();
				$mail->CharSet = $sas_lang['lang_charset'] ;
				$mail->From = $sas_config['email']; //site email address
				$mail->FromName = $sas_config['sitename'];
				$mail->Subject = $sas_config['sitename'];
				$mail->Body = $msg;
				$mail->IsHTML(true);
				$mail->AddAddress($sas_config['email']); //add email to the list
				$mail->Send();
			}
			mysql_query("UPDATE $table_users SET invalid_logins = invalid_logins + 1 WHERE username = '" . $login['user'] . "'");
			
		}
		//insert into the logging table	
		$log_msg = "for user: <b>" . $login['user'] . "</b> <font color=\"red\">failed!</font>";
		mysql_query("INSERT INTO $table_logging (filename, line, code, message, date) 
				VALUES('IP: $ip - Login ', '-', '9999', '$log_msg', now())");
		return FALSE;
	}
				
} // end of the 'verify_logon()' function

function anti_injection($user, $pass)
{
	global $sas_lang;
	# We'll first get rid of any special characters using a simple regex statement.
	# After that, we'll get rid of any SQL command words using a string replacment.
	$banlist = array (
		"insert",
		"select",
		"update",
		"delete",
		"distinct",
		"having",
		"truncate",
		"replace",
		"handler",
		"like",
		" as",
		" or",
		"procedure",
		"limit",
		"order by",
		"group by",
		" asc",
		"desc"
	);
	if (eregi("[a-zA-Z0-9]+", $user))
	{
		$user = trim(str_replace($banlist, '', strtolower($user)));
	}
	else
	{
		$user = NULL;
	}
	# Now to make sure the given password is an alphanumerical string
	# devoid of any special characters. 
	if (eregi("[a-zA-Z0-9]+", $pass))
	{
		$pass = trim(str_replace($banlist, '', strtolower($pass)));
	}
	else
	{
		$pass = NULL;
	}
	# Now to make an array so we can dump these variables into the SQL query.
	# If either user or pass is NULL (because of inclusion of illegal characters),
	# the whole script will stop dead in its tracks.
	$array = array (
		'user' => $user,
		'pass' => $pass
	);

	if (!in_array(NULL, $array))
	{
		return $array;
	}
}

function is_empty_folder($dir)
//function to see if a given directory is empty
{
	if (is_dir($dir))
	{
		$dl = opendir($dir);
		if ($dl)
		{
			while ($name = readdir($dl))
			{
				if (!is_dir("$dir/$name"))
				{
					return false;
					break;
				}
			}
			closedir($dl);
		}
		return true;
	}
	else
		return true;
}

function random_code($size)
{
	// generate an random alphanumeric code $size positions long.
	$final_rand = "";
	srand((double) microtime() * 10000000);
	$alpha = array (
		"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","X","Y","Z","1","2","3","4","5","6","7","8","9","0"	);
		
	$rand_keys = array_rand($alpha, $size);
	for ($i = 0; $i <= $size -1; $i++)
	{
		$final_rand .= $alpha[$rand_keys[$i]];
	}
	return $final_rand;
}

function load_language($cmsdir, $path)
//function which load language file, first try if a changed by user
//language file exists, if not load the standard delivered S@S one.
{
	global $sas_lang, $sas_config;

	$lang_path = $cmsdir . "languages/" . $sas_config['language'] . "/" . $path . "/" . $sas_config['language'];
	$lang_path = str_replace("//", "/", $lang_path);

	if (file_exists($lang_path . "_user.php"))
	{
		include ($lang_path . "_user.php");
	}
	elseif (file_exists($lang_path . ".php"))
	{
		include ($lang_path . ".php");
	}
	else
	{
		include ($cmsdir . "languages/EN/" . $path . "/EN.php");
	}

	return $sas_lang;
} // end of the 'load_language()' function

function remove_special_characters($string)
{
	# Remove spaces, apostrophe, exclamation marks  and replace them with underscore
	$string = preg_replace("/[^a-zA-Z0-9-.]/", "_", $string);

	return $string ;
} // end of the 'remove_special_characters()' function

function sas_move_uploaded_file($write_path, $file_name, $temp_file)
{
	# this function is called when move_uploaded_file() function is needed for a file upload
	# parameters: 
	# $write_path: path relative to the starnet directory eg. media/gallery
	# $file_name : the filename to be stored
	# $temp_file : the temporary filename of the upload.
	# check if $write_path contains ../ if so exit.
	# check if the file type is allowed to be uploaded.
	# remove special characters from filename.
	# upload file in the $write_path directory

	if (strpos($write_path, "../") === FALSE) //check if someone is trying to fool us.
	{
		global $db_server, $db_username, $db_password, $db_name, $table_configuration;
		mysql_connect("$db_server", "$db_username", "$db_password");
		mysql_select_db("$db_name");

		$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'serverpath'";
		$result = mysql_query($query); //get the document root of the site
		$serverpath = mysql_result($result, 0);
		unset ($query);
		unset ($result);

		$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'user_path'";
		$result = mysql_query($query); //get the directoryname of the cms
		$userpath = mysql_result($result, 0);
		unset ($query);
		unset ($result);
		
		$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'valid_file_extentions'";
		$result = mysql_query($query); //get the allowed file extentions
		$valid_types = explode(",", mysql_result($result, 0));
		unset ($query);
		unset ($result);

		$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'forbidden_file_extentions'";
		$result = mysql_query($query); //get the allowed file extentions
		$forbidden_types = explode(",", mysql_result($result, 0));
		unset ($query);
		unset ($result);

		$pos = strrpos($file_name, "."); //get last position of point
		$file_type = strtolower(substr($file_name, $pos+1)); //get the file extention from that point on.

		if ((!in_array($file_type, $valid_types)) OR (in_array($file_type, $forbidden_types))) //check if file type is allowed.
		{
			print "<script language=\"Javascript\">
						   <!--
						   alert (\"This file type: $file_type is not allowed!\");
						   //-->
						   </script>";
			return FALSE;
		}
		$file_name = remove_special_characters($file_name); //we remove special characters from filename						

		if (strrpos($serverpath, '/') != strlen($serverpath) - 1)
		{
			$serverpath .= '/'; //add last slash if not present
		}

		if (substr($userpath, 0, 1) == "/")
		{
			$userpath = substr($userpath, 1); //strip first slash
		}

		$serverpath = $serverpath . $userpath . "/" . $write_path; //add the write_path to the serverpath		

		if (move_uploaded_file($temp_file, $serverpath . "/" . $file_name))
		{
			// set permission  file bits
			@ chmod($serverpath . "/" . $file_name, 0644);
			return TRUE;
		}
		else
		{
			print "<script language=\"Javascript\">
						   <!--
						   alert (\"File upload error!\");
						   //-->
						   </script>";
			return FALSE;
		}
	}
} // end of the 'sas_move_uploaded()' function

function delete_files($target)
{
	//function which deletes files and directories from the pupils directory
	//is called when a pupil, project or teacher is deleted from the system

	global $sas_config;

	$exceptions = array (
		".",
		".."
	); //skip those

	$sas_path = $sas_config['serverpath'] . $sas_config['user_path'] . "/studentpages/";
	$dh = opendir($sas_path . $target);

	while (false !== ($file_name = readdir($dh)))
	{
		if (!in_array($file_name, $exceptions))
		{
			if (is_dir($sas_path . $target . "/" . $file_name))
			{
				// recurse subdirectory; call of function recursive
				delete_files($target . "/" . $file_name, $exceptions);
				rmdir($sas_path . $target . "/" . $file_name);
			}
			elseif (is_file($sas_path . $target . "/" . $file_name))
			{
				// unlink file
				unlink($sas_path . $target . "/" . $file_name);
			}
		}
	}

	closedir($dh);
	return true;
} // end of the 'delete_files()' function

function myErrHandler($errno, $message, $errFile, $errLine) 
{
//error handler function which will create an error message and sent it
//via the mail_error function to the admin email address.
global $sas_config, $cmsdir, $dbprefix ;

$old_error_reporting = error_reporting(0); // switch off error reporting

$send_mail = 0 ;  //set to 1 when we want a mail send
$redirect_to_errorpage = 0 ; //set to 1 if we want redirect to error page
$log_error = 1 ;	//log the error in the log table

	switch ($errno)
	{
		case 1: //E_ERROR:
		$send_mail = 1 ;
		$redirect_to_errorpage = 1 ;
		case 4: //E_PARSE:
		break;
		case 2: // E_WARNING:
		$send_mail = 1 ;
		$redirect_to_errorpage = 1 ;
		break;
		case 8: //E_NOTICE:
		$log_error = 0 ;	//we do not log these
		break ;
		case 16: //E_CORE_ERROR:
		break ;
		case 32: //E_CORE_WARNING:
		break;
		case 64: //E_COMPILE_ERROR:
		break;
		case 128: //E_COMPILE_WARNING:
		break;
		case 256: //E_USER_ERROR:
		break;
		case 512: //E_USER_WARNING:
		$send_mail = 1 ;
		$redirect_to_errorpage = 1 ;
		case 1024: // E_USER_NOTICE:
		break;
		case 2048: // E_STRICT:
		$log_error = 0 ;	//we do not log these
		break;
	}

$self_url = sprintf('http%s://%s%s',
  (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == TRUE ? 's': ''),
  $_SERVER['HTTP_HOST'],
  $_SERVER['REQUEST_URI']);
 	
$table_logging = $dbprefix . "logging";
$msg = "Date/time : " . date("j F Y, G:i:s ") . "<br>"
		. "File: $errFile<br>"
		. "Line: $errLine<br>"
		. "Code: $errno<br>"
		. "Message: $message<br>"
		. "Url: $self_url <br>";

$message .=  "<br>Url: " . $self_url ;
$message .=  "<br><b>Backtrace: </b><br />" ;
//get backtrace
$backtrace = debug_backtrace(); 

for($i = 0; $i < count($backtrace); $i++) 
{ 
	$message .= "#" . $i . ': ' . $backtrace[$i]['function'] . '('  . $backtrace[$i]['file'] . '(' . $backtrace[$i]['line'] . '))<br>'; 
}

$message = addslashes($message);
$errFile = addslashes($errFile);
		
	if($send_mail == 1)
	{
	//look to see if message happend before this day, if so don't send an other mail
	$query = "SELECT id FROM $table_logging WHERE filename = '$errFile' AND code = '$errno' AND DATE_FORMAT(date, '%Y-%m-%d') >= DATE_FORMAT(current_date(), '%Y-%m-%d')";
	$result = mysql_query($query);
	$Reccount = mysql_num_rows($result);
		if($Reccount == 0 )
		{
			mail_error($msg) ;
		}
	}

	if($log_error == 1)
	{
		//insert into the logging table	
		mysql_query("INSERT INTO $table_logging (filename, line, code, message, date) 
						VALUES( '$errFile', '$errLine', '$errno', '$message', now())");
	}
	
	//if we have $_SESSION['editor'] set we assume we are logged in as S@S admin.
	if(($redirect_to_errorpage == 1) AND (IsSet($_SESSION['editor']) == FALSE))
	{
		//redirect user to an general error page, if we are in S@S admin we don't
		print "<script language='javascript'>
				  window.location = '$sas_config[url]$cmsdir/error.html'
				  </script>";
	}
	
	if(($redirect_to_errorpage == 1) AND (IsSet($_SESSION['editor'])))	//we are in S@S admin
	{
		print "<span class=\"error\">".stripslashes($message)."</span><p>" ;	//just print the error
	}

error_reporting($old_error_reporting); // switch on error reporting 	
}//end of the myErrHandler function

function mail_error($message)
{
//send a severe error message via email to site admin.
global $sas_config ;
	
	if(trim($sas_config['logging_email']) != "")
	{
	$subject = "Error report for : " .$_SERVER[SERVER_NAME];
	require("class.phpmailer.php");          //use the phpmailer class
	$mail = new PHPMailer();
	$mail->From = $sas_config['email'];           //site email address
	$mail->FromName = $sas_config['sitename'];
	$mail->Subject = $subject;
	$mail->Body = $message;
	$mail->IsHTML(true);
	$mail->AddAddress($sas_config['logging_email']); 
	$mail->Send() ;
	}
}//end of the mail_error function

function convert_date($date)
{ 
//convert date to %Y-%m-%d (mysql format)
global $sas_config ;
$date_format = $sas_config['dateformat'];

//first check wich date delimiter will be used: - or . or /
if (strpos($date, "-") !== FALSE )
{
	$delim = "-" ;
}
elseif (strpos($date, ".") !== FALSE )
{
	$delim = "." ;
}
elseif (strpos($date, "/") !== FALSE )
{
	$delim = "/" ;
}

$date_array = explode($delim, $date);
$date_format_array = explode($delim, $date_format);

foreach ($date_format_array as $key => $value)
{
	if ($value == "%Y")
	{
		$final_date['%Y'] = $date_array[$key];
	}
	if ($value == "%m")
	{
		$final_date['%m'] = $date_array[$key];
	}
	if ($value == "%d")
	{
		$final_date['%d'] = $date_array[$key];
	}
}
return $final_date['%Y'] ."-".$final_date['%m'] ."-" .$final_date['%d'] ;
}

function login_form ($option, $action, $header) 
{
	//function to create a login form used by admin , pupils and teacher login.
	
	global $sas_lang, $username, $cmsdir, $site_url ;
	
	print "<form method=\"post\" action=\"".$action."\" name=\"loginform\" />\n
			<table><tr><td colspan=\"2\">" . $header . "</td></tr>\n";
	print "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
	
	print "<tr><td align=\"right\"><b>" . $sas_lang['username'] . " :</b></td>
		<td><input tabindex=\"1\" type=\"text\" name=\"user_username\" size=\"25\" value=\"$username\" style=\"color : black; font-size : 14px; border : 1px inset #CCDAEC;\" /></td></tr>\n
		<tr><td align=\"right\"><b>" . $sas_lang['password'] . " :</b></td>
		<td><input tabindex=\"2\" type=\"password\" name=\"user_password\" size=\"25\" style=\"color : black; font-size : 14px; border : 1px inset #CCDAEC;\" /></td></tr>\n";
				 
	if ($option == "new_password") //passwords reset
	{
		print "<tr><td>&nbsp;</td></tr><tr><td align=\"right\"><b>" . $sas_lang['password_new'] . ":</b></td></tr>
				 <tr><td align=right><b>" . $sas_lang['password'] . "1:&nbsp;</b></td>
				 <td> <input type=\"password\" tabindex=\"3\" name=\"password_new1\" size=\"25\"></td>
				</tr>\n
				<tr>
				 <td align=right><b>" . $sas_lang['password'] . "2:&nbsp;</b></td>
				 <td> <input type=\"password\" tabindex=\"4\" name=\"password_new2\" size=\"25\"/>
				 <input type=\"hidden\" name=\"option\" value=\"save_new_password\"/></td>
				</tr>\n";
	}
	else
	{
		print "<tr>
			   <td>&nbsp;</td>
			   <td><a href=\"$site_url$cmsdir/sendpw.php?option=public\">" . $sas_lang['logged_password_forget'] . "</a>\n
			   <input type=\"hidden\" name=\"option\" value=\"userlogin\"/>
				</td>       
				</tr>\n";
	}
	print "<tr>
			<td colspan=\"2\" align=\"right\"><input tabindex=\"5\" type=\"submit\" class=\"btn\" value=\"" . $sas_lang['login'] . "\"/></td>\n
			</tr></table></form>\n";
}

function fck_editor_small($field_name, $content, $oFCKeditor)
{
	global $cmsdir, $sas_config ;
	
	$fck_lang = strtolower($sas_config['language']);
	$theme_css = $sas_config['url'] . $cmsdir . "/themes/" . $sas_config['theme'] . "/style.css";
	
	$oFCKeditor = new FCKeditor($field_name);
	$oFCKeditor->BasePath = 'editors/fckeditor/';
	$oFCKeditor->BaseHref = $config['site_url'];
	$oFCKeditor->Config['EditorAreaCSS'] = $theme_css;
	$oFCKeditor->Config['AutoDetectLanguage'] = false ;
	$oFCKeditor->Config['DefaultLanguage'] = $fck_lang;
	$oFCKeditor->Width = '100%';
	$oFCKeditor->Height = 200;
	$oFCKeditor->ToolbarSet = 'Basic' ;
	$oFCKeditor->Value = $content;
	$oFCKeditor->Create();

}

function check_install_dir() 
{
//function to check the contents of the starnet/install directory
//give a warning popup if php files are present.	
	global $cmsdir ;
	
	$dir = "install/";
	$error = FALSE;

	if (is_dir($dir))
	{
		if ($dh = opendir($dir))
		{
			while (($file = readdir($dh)) !== false)
			{
				if (substr($file, strrpos($file, '.')) == ".php")
				{
					$error = TRUE;	//if we find a php file set $error
				}
			}
			closedir($dh);
		}
	}
	if ($error == TRUE) //if install is not empty , give warning.
	{
		print "<script language=\"Javascript\">
			   <!--
			   alert (\"Security warning: Please delete the contents of the $cmsdir/install directory!\")
			   //-->
			   </script>";
	}
}
?>